// NOTE CALLIBRATION VALUES
// Ideal readout rates is from 33K354Hz at the low end of the octave, to 62K969Hz at the high end.
// If thats beyond your hardware, define a value in "cal_ref_octave_start. It will lower the readout rate while
// still keeping everything in tune, at the cost of higher alias distortion.
// 24  = 33.35KHz to 62.97KHz
// 12 = 16.68KHz to 31.48KHz
// 0 =  8.34KHz to 15.74KHz
// Values are not limoted to 0, 12 or 24. Any value from 0 to 24 can be used.

const int8 cal_ref_octave_start = 10; // START OF REFERENCE OCTAVE. VALID VALUES ARE 0 TO 24
const int8 cal_osc = 17; // Fine tune oscillator to have A4 play as close to 440.000Hz as possible.

const int16 cal_osc_delay_startup = 65000; // Not a spesific value but if too high or too low the osc will take several seconds to get up to speed. 65000 should be OK.

int8 phase = 1;
int8 phase8 = 1;
int8 _phase = 0;
//int8 inv_phase;
//int8 phase_next;

int8 inv_dp;

int16 osc1_delay = cal_osc_delay_startup;
int16 osc1_delay_target = cal_osc_delay_startup;

int8 wav_step = 1;
int8 wav_step_target = 1;

//int8 osc_ptr = 0;

//int8 p;
int8 wavlet[4];
int8 wavlet_ptr = 0;
int8 dac8 = 0;
int16 dac16;
int8 phase_now = 0;
int8 phase_prev = 0;

const int8 wSquare = 0;
const int8 wSaw0   = 1;
const int8 wSaw1   = 2;
const int8 wPulse  = 3;
const int8 wDouble = 4;
const int8 wPole   = 5;
const int8 wReso1  = 6;
const int8 wReso2  = 7;
const int8 wReso3  = 8;
const int8 wReso4  = 9;

   void zero_proc(){
      DCA_now = DCA_next;
      wav_step = wav_step_target;
      
      if (glide){
         if (osc1_delay > osc1_delay_target) osc1_delay--;
         if (osc1_delay < osc1_delay_target) osc1_delay++;
      }
      else osc1_delay = osc1_delay_target;      
      
     inv_dp = DCF_LFO_now; // LFO;//sub_osc;     
      dp = 255 - inv_dp;   
   }

// OSCILLATOR //////////////////////////////////////////////////////////////////

void osc_thread(){

//int8 b1;
int16 phase16, inv_phase16;

//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>.
//wav_step=1;
     //DCA_now = DCA_next;
/*
   //if (dac8==0){ // ZERO CROSSING DETECTOR
   //if (dac8==127){
   if (_phase>242){ // ZERO CROSSING DETECTOR
      zero_crossed = 1;
      DCA_now = DCA_next;

      wav_step = wav_step_target;
//      osc1_delay = osc1_delay_target;      
      
      if (glide){
         if (osc1_delay > osc1_delay_target) osc1_delay--;
         if (osc1_delay < osc1_delay_target) osc1_delay++;
      }
      else osc1_delay = osc1_delay_target;      
      
      //if (DCF_next >= sub_osc) DCF_next -= sub_osc;  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< LFO
      //else DCF_next = 0;
      
      
     inv_dp = DCF_LFO_now; // LFO;//sub_osc;     
//      inv_dp = make8(DCF_next,1);//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<,disabled LFO
      
//      if (inv_dp >= LFO) inv_dp -= LFO;  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< LFO
//      else inv_dp = 0;      
      
      dp = 255 - inv_dp;
     
   }     
*/       



//------------------------------------------------------------------------------

   //if ((_phase>242)&&(wavlet_ptr>1)){ // ZERO CROSSING DETECTOR
   if (dac8 == 0){
      zero = 1;
      zero_proc();      
   }

//------------------------------------------------------------------------------

     phase16 =  phase;
     phase8 = phase;
     
     switch (wavlet[wavlet_ptr]){
          case wSquare : goto SQUARE;
          case wSaw0   : goto SAW0;
          case wSaw1   : goto SAW1;
          case wPulse  : goto PULSE;
          case wDouble : goto D0UBLE;
          case wPole   : goto POLE;
          case wReso1  : goto RESO1;
          case wReso2  : goto RESO2;
          case wReso3  : goto RESO3;
          case wReso4  : goto RESO4;
     }
/*
     SQUARE: if (phase <= dp)   dac8 = lut_sine[make8(phase16 * lut_shrink[dp], 1)]     ; else dac8 = 127                                                                       ; goto osc_done;
     SAW0  : if (phase <= dp)   dac8 = lut_sine[make8((phase * lut_shrink[dp]), 1)]     ; else dac8 = lut_sine[255 - make8((phase16 - dp) * lut_stretch[inv_dp], 1)]            ; goto osc_done;
     SAW1  :                    dac8 = lut_sine[make8(phase16 * lut_stretch[inv_dp], 1)];                                                                                       ; goto osc_done;
     D0UBLE: if (phase <= dp)   dac8 = lut_sine[make8(phase16 * lut_shrink[dp], 1)]     ; else dac8 = lut_sine[255-(phase - dp)]                                                ; goto osc_done;
     PULSE : if (phase < inv_dp)dac8 = 0                                                ; else dac8 = lut_sine[make8((phase16 - inv_dp) * lut_shrink[dp], 1)]                   ; goto osc_done;
     POLE  : if (phase <= dp)   dac8 = lut_sine[phase]                                  ; else dac8 = lut_sine[255 - make8((255 - phase) * lut_shrink[(255-phase) - inv_dp], 1)]; goto osc_done;
     RESO1 :                    dac8 = lut_sine[make8(phase16 * lut_shrink[dp], 1)]     ;                                                                                       ; goto osc_done;
     RESO2 : if (phase <= dp)   dac8 = lut_sine[phase]                                  ; else dac8 = lut_sine[255 - make8(inv_phase16 * lut_shrink[(255-phase) - inv_dp], 1)]  ; goto osc_done;
     RESO3 : if (phase <= dp)   dac8 = lut_sine[phase]                                  ; else dac8 = lut_sine[255 - make8(inv_phase16 * lut_shrink[(255-phase) - inv_dp], 1)]  ; goto osc_done;
     RESO4 : if (phase <= dp)   dac8 = lut_sine[phase]                                  ; else dac8 = lut_sine[255 - make8(phase16 * lut_shrink[phase - inv_dp], 1)]            ; goto osc_done;
*/
     SQUARE: if (phase <= dp)   _phase = make8(phase16 * lut_shrink[dp], 1)     ; else _phase = 255                                                             ; goto osc_done;
     SAW0  : if (phase <= dp)   _phase = make8((phase * lut_shrink[dp]), 1)     ; else _phase = 255 - make8((phase16 - dp) * lut_stretch[inv_dp], 1)            ; goto osc_done;
     SAW1  :                    _phase = make8(phase16 * lut_stretch[inv_dp], 1);                                                                               ; goto osc_done;
     D0UBLE: if (phase <= dp)   _phase = make8(phase16 * lut_shrink[dp], 1)     ; else _phase = 255-(phase - dp)                                                ; goto osc_done;
     PULSE : if (phase < inv_dp)_phase = 0                                      ; else _phase = make8((phase16 - inv_dp) * lut_shrink[dp], 1)                   ; goto osc_done;
     POLE  : if (phase <= dp)   _phase = phase                                  ; else _phase = 255 - make8((255 - phase) * lut_shrink[(255-phase) - inv_dp], 1); goto osc_done;
     RESO1 :                    _phase = make8(phase16 * lut_shrink[dp], 1)     ;                                                                               ; goto osc_done;
     RESO2 : if (phase <= dp)   _phase = phase                                  ; else _phase = 255 - make8(inv_phase16 * lut_shrink[(255-phase) - inv_dp], 1)  ; goto osc_done;
     RESO3 : if (phase <= dp)   _phase = phase                                  ; else _phase = 255 - make8(inv_phase16 * lut_shrink[(255-phase) - inv_dp], 1)  ; goto osc_done;
     RESO4 : if (phase <= dp)   _phase = phase                                  ; else _phase = 255 - make8(phase16 * lut_shrink[phase - inv_dp], 1)            ; goto osc_done;

     
      
     //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;;;;

osc_done:

    dac8 = lut_sine[_phase];

     phase_now = phase_now + wav_step;

     if (wavlet_ptr < 2) dac8 = 127 + dac8;
     else dac8 = 127 - dac8;

     if (phase_now < phase_prev){
        wavlet_ptr++;
        if (wavlet_ptr > 3){
            wavlet_ptr = 0;
            if (wav_step > 1) if (!bit_test(phase_now, 0)) phase_now++;


if (!zero) zero_proc();
zero = 0;

        }
     };
     phase_prev = phase_now;

     if (bit_test(wavlet_ptr, 0)){ // if odd - ie: wavelts 1 & 3
         if (phase_now == 0) phase = 255;
         else phase = 255 - phase_now + 1;
     }
     else phase = phase_now;
//if(glide)dac8=0;
   /* Amplitude */   
   dac16 = dac8;
   dac16 *= make8(DCA_now, 1);
 
   // PWM out
   CCPR1L = make8(dac16, 1);
   bit_clear(CCP1CON, 5);
   if (bit_test(dac16, 7))bit_set(CCP1CON, 5);
   bit_clear(CCP1CON, 4); 
   if (bit_test(dac16, 6))bit_set(CCP1CON, 4);
}

////////////////////////////////////////////////////////////////////////////////

//------------------------------------------------------------------------------

const int16 getDelay[36]={
64341,64408,64471,64531,64587,64640,64690,64738,64783,64825,64865,64902,
64938,64971,65003,65033,65061,65088,65113,65136,65159,65180,65200,65219,
65236,65253,65269,65284,65298,65311,65324,65336,65347,65357,65367,65377
};

//------------------------------------------------------------------------------

void Note(int8 midi){
int8 _key = 0;
int8 _step = 1;  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<not sure if should be 1. Maybe 0?
int8 _ref_end = cal_ref_octave_start + 11;
   if (midi < 24)midi = 24;
   if (midi > 107)midi = 107; 
   _key = midi;
   while (_key > _ref_end){
      _step++;
      _key -= 12;      
   }

   osc1_delay_target = getDelay[_key]+ cal_osc;
 
   wav_step_target = 1 << _step;
   Gate = 1;
   if (mTrigger){
      osc1_delay = osc1_delay_target;
      DCAenv_start();
      DCFenv_start();
      mTrigger = 0;
      
   }
   else{
      if (env_amp_retrig == 1) DCAenv_start();
      if (env_filt_retrig == 1) DCFenv_start(); 
   }

   //  0|1|2 [0][1]
   //  [4][5][3][2]
   if (vel_filt){
      //DCFenv_S = mVel_next * 2;
      
      if (mVel_next > 63) DCFenv_S = 255;
      else DCFenv_S = mVel_next * 4; 
      
   }
   else DCFenv_S = pot5;
   
   
}

//------------------------------------------------------------------------------



