//#define led0_pin   PIN_B7
//#define led1_pin   PIN_B6

#define midi_ch0_pin   PIN_A0
#define midi_ch1_pin   PIN_A1
#define midi_ch2_pin   PIN_A2
#define midi_ch3_pin   PIN_A3

#define wave_0_pin   PIN_A0
#define wave_1_pin   PIN_A1
#define wave_2_pin   PIN_A2
#define wave_3_pin   PIN_A3

#define sw0_pin   PIN_B0
#define sw1_pin   PIN_B1

//#define sw2_pin   PIN_B1
/*
#define pot0_pin   PIN_A0
#define pot1_pin   PIN_A1
#define pot2_pin   PIN_A2
#define pot3_pin   PIN_A3
#define pot4_pin   PIN_B0
*/
//#define pot5_pin   PIN_B1

#define pot_common_pin  PIN_B2
#define midi_common_pin PIN_A4
#define wave_common_pin PIN_B5
#define misc_common_pin PIN_A5

int8 ui_ptr = 0;

int8 const pot_debounce_cnt = 10; // prevents pot noise. Value needs to be the same this number of times before change registers.

//------------------------------------------------------------------------------

void pot_debounce(int8 pot, int8 &pot_old, int8 &pot_debounce_cntr, int1 &pot_changed){
   if (pot == pot_old)pot_debounce_cntr = pot_debounce_cnt;
   else{
      if (pot_debounce_cntr > 0)pot_debounce_cntr--;
      else{
         pot_old = pot;
         pot_debounce_cntr = pot_debounce_cnt;
         pot_changed = 1;
      }   
   }
}

//------------------------------------------------------------------------------

void set_ui_ports_analog(){
   PCFG6 = 1; // 1 = digital, 0 = anlog port
   PCFG5 = 0; // 1 = digital, 0 = anlog port
   PCFG4 = 0; // 1 = digital, 0 = anlog port
   PCFG3 = 0; // 1 = digital, 0 = anlog port
   PCFG2 = 0; // 1 = digital, 0 = anlog port
   PCFG1 = 0; // 1 = digital, 0 = anlog port
   PCFG0 = 0; // 1 = digital, 0 = anlog port
   //ADON  = 1; // ADC on bit. 1 = enabled, 0 = disabled.   
}

//------------------------------------------------------------------------------

void set_ui_ports_digital(){
   //ADON  = 0; // ADC on bit. 1 = enabled, 0 = disabled.   
   PCFG6 = 1; // 1 = digital, 0 = anlog port
   PCFG5 = 1; // 1 = digital, 0 = anlog port
   PCFG4 = 1; // 1 = digital, 0 = anlog port
   PCFG3 = 1; // 1 = digital, 0 = anlog port
   PCFG2 = 1; // 1 = digital, 0 = anlog port
   PCFG1 = 1; // 1 = digital, 0 = anlog port
   PCFG0 = 1; // 1 = digital, 0 = anlog port   
}

//------------------------------------------------------------------------------

void set_adc_channel(int8 ch){
   CHS2 = bit_test(ch, 2);
   CHS1 = bit_test(ch, 1);
   CHS0 = bit_test(ch, 0);
}

//------------------------------------------------------------------------------

void init_adc(){
   VCFG1 = 0; // +Vref = Vdd
   VCFG0 = 0; // -Vref = Vss
/* 
   PCFG6 = 1; // 1 = digital, 0 = anlog port
   PCFG5 = 0; // 1 = digital, 0 = anlog port
   PCFG4 = 0; // 1 = digital, 0 = anlog port
   PCFG3 = 0; // 1 = digital, 0 = anlog port
   PCFG2 = 0; // 1 = digital, 0 = anlog port
   PCFG1 = 0; // 1 = digital, 0 = anlog port
   PCFG0 = 0; // 1 = digital, 0 = anlog port
*/ 
   ADFM  = 0; // 1 = Right justified, 0 = Left justified
   ACQT2 = 1; // ADC acquisition time
   ACQT1 = 1; // ADC acquisition time
   ACQT0 = 1; // ADC acquisition time
   ADCS2 = 1; // Conversion Clock Select (must be set to "110 = Fosc/64"  if CLK = 40MHz)
   ADCS1 = 1; // Conversion Clock Select (must be set to "110 = Fosc/64"  if CLK = 40MHz)
   ADCS0 = 0; // Conversion Clock Select (must be set to "110 = Fosc/64"  if CLK = 40MHz)
ADON  = 1; // ADC on bit. 1 = enabled, 0 = disabled.
   set_ui_ports_digital();
}

//------------------------------------------------------------------------------

void UI_thread(){
int8 te;   

   switch (ui_ptr){
      case 0  : goto ui_00; // switches : Waveform + Amplitude envelope behaviour
      case 1  : goto ui_01; // switches : MIDI channel + Filter envelope behaviour
      case 2  : goto ui_02; // dac 0
      case 3  : goto ui_03; // dac 1
      case 4  : goto ui_04; // dac 2
      case 5  : goto ui_05; // dac 3
      case 6  : goto ui_06; // dac 4
      case 7  : goto ui_07; // dac 5
   }
   goto ui_00;


      // Reading Switches
      //-----------------
      set_ui_ports_digital();


ui_00:
      // WAVEFORM
      //---------
/*      
      output_bit(pot_common_pin, 1);
      output_bit(wave_common_pin, 0);
      output_bit(midi_common_pin, 1);
      output_bit(misc_common_pin, 1);

*/      
      
//a();
//output_bit(led0_pin, input(pin_A4));
//output_bit(led0_pin, 1);
      te = input_a();
      te = te ^ 0b11111111; // XOR to invert
      te = te & 0xF; // get LSnibble
      te--;
     
      switch (te){
         case  0 : goto wav_00;
         case  1 : goto wav_01;
         case  2 : goto wav_02;
         case  3 : goto wav_03;
         case  4 : goto wav_04;
         case  5 : goto wav_05;
         case  6 : goto wav_06;
         case  7 : goto wav_07;
         case  8 : goto wav_08;
         case  9 : goto wav_09;
         case 10 : goto wav_10;
         case 11 : goto wav_11;   
      }
   
      wav_00 : wavlet[0] = wpole    ; wavlet[1] = wpole     ; wavlet[2] = wpole     ; wavlet[3] = wpole     ; goto wav_done;
      wav_01 : wavlet[0] = wsquare  ; wavlet[1] = wsquare   ; wavlet[2] = wsquare   ; wavlet[3] = wsquare   ; goto wav_done;
      wav_02 : wavlet[0] = wsaw0    ; wavlet[1] = wsaw1     ; wavlet[2] = wsaw1     ; wavlet[3] = wsaw0     ; goto wav_done;
      wav_03 : wavlet[0] = wpulse   ; wavlet[1] = wpulse    ; wavlet[2] = wpulse    ; wavlet[3] = wpulse    ; goto wav_done;
      wav_04 : wavlet[0] = wsquare  ; wavlet[1] = wsaw0     ; wavlet[2] = wsaw0     ; wavlet[3] = wsquare   ; goto wav_done;
      wav_05 : wavlet[0] = wsquare  ; wavlet[1] = wdouble   ; wavlet[2] = wdouble   ; wavlet[3] = wsquare   ; goto wav_done;
      wav_06 : wavlet[0] = wsaw0    ; wavlet[1] = wsaw0     ; wavlet[2] = wsaw0     ; wavlet[3] = wsaw0     ; goto wav_done;
      wav_07 : wavlet[0] = wdouble  ; wavlet[1] = wdouble   ; wavlet[2] = wdouble   ; wavlet[3] = wdouble   ; goto wav_done;
      wav_08 : wavlet[0] = wsquare  ; wavlet[1] = wsaw1     ; wavlet[2] = wsaw1     ; wavlet[3] = wsquare   ; goto wav_done;
      wav_09 : wavlet[0] = wpulse   ; wavlet[1] = wsquare   ; wavlet[2] = wsquare   ; wavlet[3] = wpulse    ; goto wav_done;
      wav_10 : wavlet[0] = wdouble  ; wavlet[1] = wsaw1     ; wavlet[2] = wsaw1     ; wavlet[3] = wdouble   ; goto wav_done;
      //wav_11 : wavlet[0] = wsaw1    ; wavlet[1] = wsaw0     ; wavlet[2] = wsaw0     ; wavlet[3] = wsaw1     ; goto wav_done;   
      wav_11 : wavlet[0] = wsquare;  wavlet[1] = wreso1     ; wavlet[2] = wreso1     ; wavlet[3] = wsquare     ; goto wav_done;   
      wav_done:
   
      env_filt_sust = input(sw1_pin);
      env_filt_retrig = input(sw0_pin);       
      
      //vel_filt = !input(misc_common_pin); // filter level determined by MIDI velocity
      glide    = input(misc_common_pin);
      
      output_bit(pot_common_pin, 1);
      output_bit(wave_common_pin, 1);
      output_bit(midi_common_pin, 0);
      output_bit(misc_common_pin, 1);

      ui_ptr = 1;
      goto ui_done;
      
ui_01:
//a();
//b();
      // MIDI CHANNEL      
      //-------------
/*      
      output_bit(pot_common_pin, 1);
      output_bit(wave_common_pin, 1);
      output_bit(midi_common_pin, 0);
      output_bit(misc_common_pin, 1);
*/      
//output_bit(led0_pin, input(pin_A0));

//output_bit(led0_pin, (porta, 2));      
      te = input_a();
//te = 0b11111110;     
      te = te ^ 0b11111111; // XOR to invert
//te=0;      
//output_bit(led0_pin, (te == 0));   
//output_bit(led0_pin, 0);   
      te = te & 0xF; // get LSnibble (MIDI CHANNEL)
//output_bit(led0_pin, (te ==3));       
      te--;
      midi_my_channel = te;

/*
      te = input_a();
      te = te ^ 0b11111111; // XOR to invert
      te = te & 0xF; // get LSnibble
      te--;
*/


      env_amp_sust   = input(sw1_pin);   
      env_amp_retrig = input(sw0_pin);

      //glide    = input(misc_common_pin);   
      vel_filt = input(misc_common_pin); // filter level determined by MIDI velocity

      
      // Prepare for POT measurement
      // ---------------------------
      set_ui_ports_analog();
      output_bit(pot_common_pin, 0);
      output_bit(wave_common_pin, 1);
      output_bit(midi_common_pin, 1);
      output_bit(misc_common_pin, 1);
   
      // Start measuring pots 0 to 5
      // ---------------------------
      set_adc_channel(0); // set ADC channel
      GO_DONE = 1; // start ADC conversion
   
      ui_ptr = 2;
   
      goto ui_done;

ui_02: 
      if (ADIF){ // analog to digital conversion done?
         ADIF = 0; // clear interrupt flag
         pot0 = ADRESH; // set pot variable to measured ADC value
         pot_debounce(pot0, pot0_old, pot0_debounce_cntr, DCAenv_changed);
         set_adc_channel(1); // set next ADC channel     
         GO_DONE = 1; // start ADC conversion
         ui_ptr = 3;
      }
      goto ui_done;
   
ui_03:   
      if (ADIF){ // analog to digital conversion done?
         ADIF = 0; // clear interrupt flag
         pot1 = ADRESH; // set pot variable to measured ADC value
         pot_debounce(pot1, pot1_old, pot1_debounce_cntr, DCAenv_changed);
         set_adc_channel(2); // set next ADC channel
         GO_DONE = 1; // start ADC conversion
         ui_ptr = 4;
      }
      goto ui_done;
   
ui_04:   
      if (ADIF){ // analog to digital conversion done?
         ADIF = 0; // clear interrupt flag
         pot2 = ADRESH; // set pot variable to measured ADC value
         pot_debounce(pot2, pot2_old, pot2_debounce_cntr, DCFenv_changed);
         set_adc_channel(3); // set next ADC channel      
         GO_DONE = 1; // start ADC conversion
         ui_ptr = 5;
      }
      goto ui_done;

ui_05:   
      if (ADIF){ // analog to digital conversion done?   
         ADIF = 0; // clear interrupt flag
         pot3 = ADRESH; // set pot variable to measured ADC value
         pot_debounce(pot3, pot3_old, pot3_debounce_cntr, DCFenv_changed);
         set_adc_channel(4); // set next ADC channel      
         GO_DONE = 1; // start ADC conversion
         ui_ptr = 6;
      }
      goto ui_done;

ui_06:   
      if (ADIF){ // analog to digital conversion done?
         ADIF = 0; // clear interrupt flag
         pot4 = ADRESH; // set pot variable to measured ADC value
         pot_debounce(pot4, pot4_old, pot4_debounce_cntr, DCFenv_changed);
         set_adc_channel(5); // set next ADC channel      
         GO_DONE = 1; // start ADC conversion
         ui_ptr = 7;
      }
      goto ui_done;

ui_07:   
      if (ADIF){ // analog to digital conversion done?
         ADIF = 0; // clear interrupt flag
         pot5 = ADRESH; // set pot variable to measured ADC value
         pot_debounce(pot5, pot5_old, pot5_debounce_cntr, DCFenv_changed);

      // Prepare for reading switches
      //-----------------------------
      set_ui_ports_digital();
      
      output_bit(pot_common_pin, 1);
      output_bit(wave_common_pin, 0);
      output_bit(midi_common_pin, 1);
      output_bit(misc_common_pin, 1);


         ui_ptr = 0;
   }
   goto ui_done;

ui_done:
;
}

//------------------------------------------------------------------------------

int16 getStepSize(int8 delta, pot){
int16 d1;
   d1 = make16(delta, 0);
   d1 = d1 / (pot + 1);
   return(d1);
}

//------------------------------------------------------------------------------


//  0|1|2 [0][1]
//  [4][5][3][2]

void update_DCAenv(){

   DCAenv_changed = 0;
   DCAenv_A = GetStepSize(255, pot0);
   DCAenv_R = GetStepSize(255, pot1);
}

//------------------------------------------------------------------------------
//  0|1|2 [0][1]
//  [4][5][3][2]

void update_DCFenv(){
   DCFenv_S = pot5;
   DCFenv_changed = 0;
   DCFenv_A = GetStepSize(DCFenv_S, pot3); // DCAget_s(0, DCFenv_S, pot4);//10;
   DCFenv_R = GetStepSize(DCFenv_S, pot2); // DCAget_s(DCFenv_S, 0, pot2);//10;
}

//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
