int8 mNote_now  = 0;
//int8 mVel_now   = 0;
int8 mNote_next = 0;
int8 mVel_next  = 0;

int1 mTrigger = 0;
int1 doNote = 0;

int8 midi_running_status;
int8 midi_ptr = 0;
//int8 prev_midi_ptr;

int1 Sysex_in_progress = 0;

int8 midi_my_channel = 12;//3,

const int8 s_note_off           = 1;
const int8 s_note_on            = 3;
const int8 s_key_pressure       = 5;
const int8 s_controller_change  = 7;
const int8 s_program_change     = 9;
const int8 s_channel_pressure   = 10;
const int8 s_pitch_bend         = 11;

const int8 s_system_exclusive   = 13;
const int8 s_song_position      = 14;
const int8 s_song_select        = 16;
const int8 s_bus_select         = 17;

int8 dummy;
int8 midi_ptr_memory;

//------------------------------------------------------------------------------

void init_midi(){
int8 dummy;
   SPEN  = 1; // [1] Serial Port Enable bit 
   RX9   = 0; // [0] 9-bit Receive Enable bit (0 = 8 bit)
   SREN  = 0; // [*] Single Receive Enable bit ("Dont care" for Async)
   CREN  = 1; // [1] Continuous Receive Enable bit
   ADDEN = 0; // [0] Address Detect Enable bit ("Dont care" if RX9D = 0)
   RX9D  = 0; // 9th bit of received data
   
   TXEN  = 0; // Transmit Enable Bit (Disabled as we don't transmit in this app)
  
   CSRC   = 0; // Clock Source select bit ("Dont care" for Async)
   TX9    = 0; // 9-bit Transmit Enable Bit (0 = 8 bit)
   TXEN   = 0; // Transmit Enable Bit (Disabled as we don't transmit in this app)
   SYNC   = 0; // EUSART mode select bit (0 = Async)
   SENB   = 0; // Send Break Character bit
   BRGH   = 0; // High Baud Rate Select bit 
   
   //set baudrate
   SPBRGH = 0;
   SPBRG = 19;   
   BRG16  = 0; // 16 bit Baud rate register enable bit (0 = ignore SBGH0 byte)
   ABDEN  = 0; // Auto baud detect enable bit

   //wait until USART receiver is idle. Read whatever is in the register to prevent overflows
   while (RCIDL == 0)dummy = RCREG;
}

//------------------------------------------------------------------------------

void midi_thread(){


   int8 midi_new_byte    = 0;
   int8 midi_new_channel = 0;
   int8 midi_new_command = 0;
  
//output_bit(led0_pin, FERR);
//output_bit(led1_pin, OERR);
   
   // Clear overrun errors as the USART will shutdown after 3 overruns
   if (OERR){
      CREN = 0;
      CREN = 1;
   }


//output_bit(led1_pin, Gate); // <<<<<<<<<< GATE LED

//output_bit(led1_pin, mTrigger);
//b();
   if (RCIF == 1) midi_new_byte = RCREG;         // check if MIDI Byte received
   else goto midi_done;
//b();
   if (sysex_in_progress) goto system_exclusive1; // ignore byte content while SYSEX in progress
   
   // Check if byte received is a command
   if (bit_test(midi_new_byte, 7)){ // command? (all commands have bit 7 set. If not, it is data)
      
     // COMMAND
      midi_new_channel = midi_new_byte & 0xF; // get LSnibble (MIDI CHANNEL)
      midi_new_command = midi_new_byte >> 4; // get MSnibble  (MIDI COMMAND) 
       
//if (!all_midi_channels){
//      if (midi_new_channel != midi_my_channel){midi_ptr = 0; goto midi_done;} // Ignore messages not intended for my channel
//}
if (midi_my_channel < 11) if (midi_new_channel != midi_my_channel){midi_ptr = 0; goto midi_done;} // Ignore messages not intended for my channel


      switch(midi_new_command - 8){
         case 0 : goto note_off         ;
         case 1 : goto note_on          ;
         case 2 : goto key_pressure     ;
         case 3 : goto controller_change;
         case 4 : goto program_change   ;
         case 5 : goto channel_pressure ;
         case 6 : goto pitch_bend       ;
         case 7 : goto system_messages  ;
      }
      goto midi_done;
   }      
   
   // Byte received is not a COMMAND. Handle it as running status DATA.
   switch (midi_ptr){
      case 0  : goto midi_done          ; // do nothing
      case 1  : goto note_off1          ; // Note OFF - note
      case 2  : goto note_off2          ; // Note OFF - velocity      
      case 3  : goto note_on1           ; // No note
      case 4  : goto note_on2           ; // Note ON - velocity
      case 5  : goto key_pressure1      ; // key_pressure - key
      case 6  : goto key_pressure2      ; // key_pressure - pressure
      case 7  : goto controller_change1 ; // controller_change - controller
      case 8  : goto controller_change2 ; // controller_change - value
      case 9  : goto program_change1    ; // program_change - preset
      case 10 : goto channel_pressure1  ; // channel_pressure - value
      case 11 : goto pitch_bend1        ; // pitch_bend - bend LSB
      case 12 : goto pitch_bend2        ; // pitch_bend - bend MSB
      case 13 : goto system_exclusive1  ; // system_exclusive - anything
      case 14 : goto song_position1     ; // song_position - position LSB
      case 15 : goto song_position2     ; // song_position - position MSB
      case 16 : goto song_select1       ; // song_select - song number
      case 17 : goto bus_select1        ; // bus_select - bus number
   }
   midi_ptr = 0;
   goto midi_done;

//..............................................................................         

note_off:
   midi_ptr = s_note_off; 
   midi_running_status = midi_ptr;    
   goto midi_done;
   
note_off1:   
   mNote_next = midi_new_byte;
   midi_ptr++;
   goto midi_done;

note_off2:
   mVel_next = midi_new_byte;
   midi_ptr = midi_running_status;
   if (mNote_now == mNote_next) Gate = 0; // Check if note off message is for note currently playing else ignore
   goto midi_done;

//..............................................................................

note_on:
   midi_ptr = s_note_on; 
   midi_running_status = midi_ptr;
   goto midi_done;

note_on1:
   mNote_next = midi_new_byte;
   midi_ptr++;
   goto midi_done;

note_on2:
   mVel_next = midi_new_byte;
   midi_ptr = midi_running_status;
           
   if (mVel_next == 0){ // alternate version of note off message
      if (mNote_now == mNote_next){Gate = 0;}  // Check if note off message is for note currently playing else ignore
   }
   else{
      if (Gate) mTrigger = 0; // no trigger if a note is already playing
      else mTrigger = 1;
      DoNote = 1; // play new note, but initialise from free running loop as it takes too long to do from DCO interrupt
   }
   goto midi_done;

//..............................................................................

key_pressure:
   midi_ptr = s_key_pressure; 
   midi_running_status = midi_ptr;
   goto midi_done;

key_pressure1:
   dummy = midi_new_byte;
   midi_ptr++;
   goto midi_done;

key_pressure2:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

controller_change:
   midi_ptr = s_controller_change; 
   midi_running_status = midi_ptr;
   goto midi_done;

controller_change1:
   dummy = midi_new_byte;
   midi_ptr++;
   goto midi_done;

controller_change2:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

program_change:
   midi_ptr = s_program_change; 
   midi_running_status = midi_ptr;
   goto midi_done;

program_change1:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

channel_pressure:
   midi_ptr = s_channel_pressure; 
   midi_running_status = midi_ptr;
   goto midi_done;

channel_pressure1:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

pitch_bend:
   midi_ptr = s_pitch_bend; 
   midi_running_status = midi_ptr;
   goto midi_done;

pitch_bend1:
   dummy = midi_new_byte;
   midi_ptr++;
   goto midi_done;

pitch_bend2:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

system_messages:
         switch(midi_new_command & 0xF){ // check LS nibble
            case 0x0 : goto system_exclusive;
            case 0x1 : goto not_implemented ;
            case 0x2 : goto song_position   ;
            case 0x3 : goto song_select     ;
            case 0x4 : goto not_implemented ;
            case 0x5 : goto bus_select      ;
            case 0x6 : goto tune_request    ;
            case 0x7 : goto end_of_sysex    ;
            case 0x8 : goto timing_tick     ;
            case 0x9 : goto not_implemented ;
            case 0xA : goto start_song      ;
            case 0xB : goto continue_song   ;
            case 0xC : goto stop_song       ;
            case 0xD : goto not_implemented ;
            case 0xE : goto active_sensing  ;
            case 0xF : goto system_reset    ;
         }
   
//..............................................................................   
   
system_exclusive:
   midi_ptr_memory = midi_ptr;
   midi_ptr = s_system_exclusive;
   sysex_in_progress = 1;
   goto midi_done;

system_exclusive1:
   dummy = midi_new_byte;
   if (dummy == 0xF7){
      sysex_in_progress = 0;
      midi_ptr = midi_ptr_memory;   
   }
   goto midi_done;

//..............................................................................

song_position:
   midi_ptr = s_song_position; 
   midi_running_status = midi_ptr;
   goto midi_done;

song_position1:
   dummy = midi_new_byte;
   midi_ptr++;
   goto midi_done;

song_position2:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

song_select:
   midi_ptr = s_song_select; 
   midi_running_status = midi_ptr;
   goto midi_done;

song_select1:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

bus_select:
   midi_ptr = s_bus_select;
   midi_running_status = midi_ptr;
   goto midi_done;

bus_select1:
   dummy = midi_new_byte;
   midi_ptr = midi_running_status;
   goto midi_done;

//..............................................................................

tune_request:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

end_of_sysex:
   sysex_in_progress = 0;
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

timing_tick:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

start_song:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

continue_song:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

stop_song:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

active_sensing:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

system_reset:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................

not_implemented:
   midi_ptr = 0;
   goto midi_done;

//..............................................................................
   
midi_done:;

//------------------------------------------------------------------------------
}


